<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  
</head>

<body onload="onPageLoading()">
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <input type="button" id="btn-send" value="Send" class="btn btn-info">
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


  // gán hàm xử lý sự kiện cho sự kiện change của select car
  $("#car-select").on("change", function () {
    onCarSelectChange(this);
  });
  $("#country-select").on("change", function () {
    onCountrySelectChange(this);
  })

  // gán hàm xử lý sự kiện cho nút Send
  $("#btn-send").on("click", function () {
    onBtnSendClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm thực hiện sự kiện tải trang
  function onPageLoading() {
    loadDataToCarSelect();
    loaDataCountrySelect();
  }
  // hàm xử lý sự kiện select country
  function onCountrySelectChange(paramCountry) {
    var vCountryId = $(paramCountry).val();
    console.log("countryId : " + vCountryId);
    // xử lý front-end
    loadDataToRegionTypeCounTrySelect(vCountryId);

  }

  // hàm xử lý sự kiện select car change
  function onCarSelectChange(paramCarSelect) {
    // B1: thu thập dữ liệu
    var vBrandId = $(paramCarSelect).val();
    // b2: validate (ko có)
    // B3: xử lý front-end
    loadDataToCarTypeSelectByCarBrandId(vBrandId);
  }

  // hàm xử lý sự kiện nút send click
  function onBtnSendClick() {
    // khai báo đối tượng chứa dữ liệu
    var vFormDataObj = {
      brandId: "",
      brandName: "",
      typeId: "",
      typeName: "",
      countryId: "",
      countryName: "",
      regionId: "",
      regionName: "",
    };
    // B1: thu thập dữ liệu
    getFormData(vFormDataObj);
    // B2: validate (bỏ qua)
    // B3: xử lý front-end
    showDataToConsole(vFormDataObj);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }

  // hàm dùng để load dữ liệu vào select car
  function loadDataToCarSelect() {
    //  $(selector, { }).action()
    var vCarSelect = $("#car-select");
    for (let bI = 0; bI < gObjectCarData.length; bI++) {

      var bCarOption = $("<option/>", {
        text: gObjectCarData[bI].brandName,
        value: gObjectCarData[bI].brandId
      }).appendTo(vCarSelect);
    }
  }

  // hàm thu thập dữ liệu đầu vào
  function getFormData(paramFormObj) {
    paramFormObj.brandId = $("#car-select").val();
    paramFormObj.brandName = $("#car-select option:selected").text();
    paramFormObj.typeId = $("#car-type-select").val();
    paramFormObj.typeName = $("#car-type-select option:selected").text();
    //
    paramFormObj.countryId = $("#country-select").val();
    paramFormObj.countryName = $("#country-select option:selected").text();
    paramFormObj.regionId = $("#region-type-select").val();
    paramFormObj.regionName  = $("#region-type-select option:selected").text();
  }

  // hàm hiển thị dữ liệu vào console
  function showDataToConsole(paramFormObj) {
    console.log(paramFormObj);
    console.log("CountryId : " + paramFormObj.countryId);
    console.log("CountryName : " + paramFormObj.countryName);
    console.log("RegionId : " + paramFormObj.regionId);
    console.log("RegionName : " + paramFormObj.regionName);
  }
  // hàm load dữ liệu vào select car type dựa vào country 
  function loaDataCountrySelect(paramCountry) {
    var vCountrySelect = $("#country-select");
    for (var bI = 0; bI < gObjectCountryData.length; bI++) {
      var bCountrySelect = $("<option/>", {
        value: gObjectCountryData[bI].countryId,
        text: gObjectCountryData[bI].countryName,
      }).appendTo(vCountrySelect);
    }
  }

  // hàm load dữ liệu vào select car type dựa vào car brandId
  function loadDataToCarTypeSelectByCarBrandId(paramCarBrandId) {
    var vCarTypeArr = getBrandTypeByBrandID(paramCarBrandId);
    var vCarTypeSelect = $("#car-type-select");
    // xóa trắng car type select
    vCarTypeSelect.html("");
    // nếu mảng car type ko có phần tử nào thì disable car type select
    if (vCarTypeArr.length === 0) {
      vCarTypeSelect.prop("disabled", "disabled");
    }
    else {
      vCarTypeSelect.prop("disabled", false);
      for (let bI = 0; bI < vCarTypeArr.length; bI++) {
        var bCarTypeOption = $("<option/>", {
          text: vCarTypeArr[bI].typeName,
          value: vCarTypeArr[bI].typeId
        }).appendTo(vCarTypeSelect);
      }
    }
  }
  // hàm load dữ liệu vào country select
  function loadDataToRegionTypeCounTrySelect(paramCountry) {
    var vRegionTypesData = getRegionTypesByCountryId(paramCountry);
    var vEleSelectRegion = $("#region-type-select");
    // xoá trắng region select
    vEleSelectRegion.html("");
    if (vRegionTypesData.length == 0) {
      vEleSelectRegion.prop("disabled", true);
    }
    else {
      vEleSelectRegion.prop("disabled", false);
      for (var bI = 0; bI < vRegionTypesData.length; bI++) {
        var bCountryOption = $("<option/>", {
          value: vRegionTypesData[bI].regionId,
          text: vRegionTypesData[bI].regionName,
        }).appendTo(vEleSelectRegion);
      }
    }
  }
  function getRegionTypesByCountryId(paramCountry) {
    var vRegionFound = false;
    var vRegionTypesResult = null;
    var vIterator = 0;
    while (!vRegionFound && vIterator <  gObjectCountryData.length) {
      if (gObjectCountryData[vIterator].countryId === paramCountry) {
        vRegionFound = true;
        vRegionTypesResult = gObjectCountryData[vIterator].regionTypes;
      }
      else {
        vIterator++;
      }
    }
    return vRegionTypesResult;
  }
</script>

</html>